<template>
  <div id='task_content'>
    <h1>Task: 
    <span v-if='!edited'>
      {{ task.title }} 
      duration: 
      <timer v-if='task' :init-time='Math.round(task.duration)' :timer-id='task.id'></timer>
      <button class='btn btn-success edit_task_btn' @click="toggleEdit"> 
        Edit
      </button>
    </span>
    <span v-if='edited'>
        <input
          id='task_title'
          type="text"
          placeholder="Task title"
          class="form-control"
          v-model="taskTitle"
          style='max-width: 300px;'
        />
      <button class="btn btn-primary update_task_btn" @click='updateTask'>Update</button>
    </span>
    </h1>
     id:{{ $route.params.id }}
    <h3> Time points: </h3>
    <table class="table">
      <tr>
        <th> Started at </th>
        <th> Finished at </th>
      <tr>
      <tr v-for='timePoint in timePoints' :id='"timePoint"+timePoint.id'>
        <td>
          {{ timePoint.started_at | displayDate }}
        </td>
        <td v-if='timePoint.finished_at'>
          {{ timePoint.finished_at | displayDate }}
        </td>
        <td v-else >
          -
        </td>
        <td>
          <button class='btn btn-danger' @click='deleteTimePoint(timePoint)'>
            Delete time point
          </button>
        </td>
      </tr>
    </table>
  </div>
</template>


<script>
  import moment from 'moment'
  export default {
    data () {
      return {
        taskTitle: '',
        task: '',
        edited: false,
        timePoints: []
      }
    },
    mounted() {
      if(!this.$store.state.logged) {
        this.$root.$emit('setFlashMsg', { message: 'You must be logged to visit this page', type: 'error' })
        this.$router.push('/')
      }
      this.loadTask()
    },
    filters: {
      displayDate: (val) => {
        return moment(val).format('MM/DD/YYYY hh:mm:ss')
      }
    },
    methods: {
      loadTask() {
        let id = this.$route.params.id
        const url = `/api/v1/tasks/${id}`
        this.$http.get(url, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.task = response.body.task
          this.timePoints = response.body.time_points
          this.taskTitle = response.body.task.title
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error'})
          this.$router.push('/tasks')
        })
      },
      updateTask() { 
        let id = this.$route.params.id
        const url = `/api/v1/tasks/${id}`
        this.$http.patch(url, {task: { title: this.taskTitle }}, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.task = response.body.task
          this.$root.$emit('setFlashMsg', { message: response.body.message, type: 'normal' })
          this.toggleEdit() 
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error'})
        })
      },
      toggleEdit() {
        this.edited = !this.edited
      },
      deleteTimePoint(timePoint) {
        const url = `/api/v1/time_points/${timePoint.id}`
        this.$http.delete(url, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.$root.$emit('setFlashMsg', { message: response.body.message, type: 'normal' })
          let timePointIndex = this.timePoints.indexOf(timePoint)
          this.timePoints.splice(timePointIndex, 1)
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error'})
        })
      }
    }
  }
</script>
